///////////////////////////////////////////////////////////////////////////////////
// GameStudio main script
////////////////////////////////////////////////////////////////////////////
// Files to over-ride:
// * logodark.bmp - the engine logo, include your game title
// * horizon.pcx - A horizon map displayed over the sky and cloud maps
////////////////////////////////////////////////////////////////////////////
// The PATH keyword gives directories where game files can be found,
// relative to the level directory
path "C:\\Program Files\\GStudio6\\template";	// Path to WDL templates subdirectory

////////////////////////////////////////////////////////////////////////////
// The INCLUDE keyword can be used to include further WDL files,
// like those in the TEMPLATE subdirectory, with prefabricated action
bmap loadscreenpic = <loadscreen.bmp>;
panel loadscreen {
	bmap = loadscreenpic;
	flags = refresh,d3d;
}

bmap placeholder_ = <placeholder.bmp>;
bmap splashmap = <logolite.pcx>; // the default logo in templates
bmap cppanel <checkpointpanel.bmp>;
bmap snicksm1 <snicks1.bmp>;
bmap blacked = <blackout.bmp>;
bmap lostlogo_ = <lostlogo.pcx>;
bmap titlepic = <title.bmp>;
bmap cratepantel = <cratehud2.bmp>;
bmap presentation = <prespage.bmp>;
bmap newgame = <new2.bmp>;
bmap newgamepressed = <newpressed2.bmp>;
bmap mainpanel = <newHUD.bmp>;

sound coinpickup =<beep2.wav>;
sound snickering = <snicker1.wav>;
sound lostgs = <lostgames.wav>;
sound nyshodead = <playerdead.wav>;
sound levelfinish = <levelcomplete.wav>;
sound nyshojump = <playerjump.wav>;

var canjump = 1;
var score = 0; // to avoid conflict with war death function
var cargo = 7;

string firstlevel = <Canyon3.wmb>;
string scoretext = score;
string partic = <partic.mdl>;

include <AI.wdl>;
include <mountainsnow.wdl>;

include <movement.wdl>;
include <messages.wdl>;
include <menu.wdl>;		// must be inserted before doors and weapons
include <particle.wdl>; // remove when you need no particles
include <doors.wdl>;		// remove when you need no doors
include <actors.wdl>;   // remove when you need no actors
include <weapons.wdl>;  // remove when you need no weapons
include<userctrl.wdl>;
//include <venture.wdl>;	// include when doing an adventure
include <lflare.wdl>;   // remove when you need no lens flares
include <wow.wdl>;
include <endoflevel.wdl>;

include <transporter.wdl>;
include <checkpoints.wdl>;
include <war.wdl>;      // remove when you need no fightingghtin


panel presentation_
{
	window = 0,0,640,480,presentation,0,0;
	pos_x=0;
	pos_y=0;
	flags = refresh;
}
panel publisherplaceholder
{
	window = 0,0,640,480,placeholder_,0,0;
	pos_x=0;
	pos_y=0;
	flags = refresh;
}
panel backgroundPcargo
{
	window = 10,10,41,45,cratepantel,0,0;
	pos_x=0;
	pos_y=110;
	flags = refresh, overlay;
}

panel displaycargo
{
	pos_x = 2;
	pos_y = 2;
	flags = refresh; // make it visible and displayable over the view
	DIGITS= 	50,120,1,standard_font,1,cargo;
}
panel displayscore
{
	pos_x = 2;
	pos_y = 2;
	flags = visible,refresh; // make it visible and displayable over the view
	digits = 170,75,3, standard_font, 1,score;
	DIGITS= 	170,46,3,standard_font,1,show_health;
}

panel backgroundP
{
	window = 10,10,250,100,mainpanel,0,0;
	pos_x=0;
	pos_y=0;
	flags = visible, refresh, overlay;
}
include <levelchanges.wdl>;
////////////////////////////////////////////////////////////////////////////
// The engine starts in the resolution given by the follwing vars.
// The engine starts in the resolution given by the follwing vars.
var video_mode = 6;	 // screen size 640x480
var video_depth = 16; // 16 bit colour D3D mode
var video_screen = 1;

/////////////////////////////////////////////////////////////////
// Strings and filenames
// change this string to your own starting mission message.
string mission_str = "";
string level_str = <StartMenu.WMB>; // give file names in angular brackets
string next_level = <Canyon3.WMB>;
/////////////////////////////////////////////////////////////////
// define a splash screen with the required A4/A5 logo
//in game panels

panel splashscreen {
	bmap = splashmap;
	flags = refresh,d3d;
}
panel lostsplash {
	bmap = lostlogo_;
	flags = refresh,d3d;
}
panel blacker {
	bmap = blacked;
	flags = refresh,d3d;
}


////////////////////////////////////////////////////////////////////////////
// The following script controls the sky
sky cubesky{	type = <free3+6.tga>;	layer = 1;	material = mat_sky;	flags = cube, visible;}
/////////////////////////////////////////////////////////////////
// The main() function is started at game start
function main()
{
	backgroundP.visible = off;
	displayscore.visible = off;
	person_3rd = 0.5;
	// set some common flags and variables
	//	warn_level = 2;	// announce bad texture sizes and bad wdl code
	tex_share = on;	// map entities share their textures
	init_controls();//user control define
	// center the splash screen for non-640x480 resolutions, and display it
	splashscreen.pos_x = (screen_size.x - bmap_width(splashmap))/2;
	splashscreen.pos_y = (screen_size.y - bmap_height(splashmap))/2;
	splashscreen.visible = on;
	// wait 3 frames (for triple buffering) until it is flipped to the foreground
	wait(3);

	// wait the required second, then switch the splashscreen off.
	sleep(3);
	splashscreen.visible = off;
	publisherplaceholder.visible = on;
	sleep(12);
	publisherplaceholder.visible = off;
	snd_play(lostgs, 100, 0);
	
	lostsplash.visible = on;
	sleep(0.25);
	lostsplash.visible = off;
	blacker.visible = on;
	sleep(0.25);
	lostsplash.visible = on;
	sleep(0.25);
	lostsplash.visible = off;
	blacker.visible = on;
	sleep(0.25);
	lostsplash.visible = on;
	sleep(0.25);
	lostsplash.visible = off;
	blacker.visible = on;
	sleep(0.25);
	lostsplash.visible = on;
	sleep(0.25);
	lostsplash.visible = off;
	blacker.visible = on;
	sleep(0.25);
	lostsplash.visible = on;
	sleep(4);
	lostsplash.visible = off;
	blacker.visible = off;
	wait(3);
	max_entities = 5000;
	clip_range = 1000;
	// now load the level
	level_load(level_str);
	mouse_on();
	fps_min = 30;
	fps_max = 50;// will limit fps between 30-50
	// freeze the game
	freeze_mode = 1;

	bmap_purge(splashmap);	// remove splashscreen from video memory

	// load some global variables, like sound volume
	load_status();

	// display the initial message


	// initialize lens flares when edition supports flares
	ifdef CAPS_FLARE;
		lensflare_start();
	endif;

	// use the new 3rd person camera
	move_view_cap = 1;

	// un-freeze the game
	freeze_mode = 0;

	//	client_move();	// for a possible multiplayer game
	// call further functions here...
}


/////////////////////////////////////////////////////////////////
// The following definitions are for the pro edition window composer
// to define the start and exit window of the application.
WINDOW WINSTART
{
	TITLE			"3D GameStudio";
	SIZE			480,320;
	MODE			IMAGE;	//STANDARD;
	BG_COLOR		RGB(240,240,240);
	FRAME			FTYP1,0,0,480,320;
	//	BUTTON		BUTTON_START,SYS_DEFAULT,"Start",400,288,72,24;
	BUTTON		BUTTON_QUIT,SYS_DEFAULT,"Abort",400,288,72,24;
	TEXT_STDOUT	"Arial",RGB(0,0,0),10,10,460,280;
}

/* no exit window at all..
WINDOW WINEND
{
	TITLE			"Finished";
	SIZE			540,320;
	MODE	 		STANDARD;
	BG_COLOR		RGB(0,0,0);
	TEXT_STDOUT	"",RGB(255,40,40),10,20,520,270;

	SET FONT		"",RGB(0,255,255);
	TEXT			"Any key to exit",10,270;
}*/


/////////////////////////////////////////////////////////////////
//INCLUDE <debug.wdl>;



path "c:\\program files\\gstudio6\\template";	// path to wdl templates subdirectory
panel panel_editor{
	pos_x = 0;
	pos_y = 0;
	layer = -2;
	button = 10,370,<newpressed2.bmp>,<new2.bmp>,<newover2.bmp>,newgamestart,NULL,NULL;
	flags = visible,refresh,overlay;
}
panel panel_editor3{
	pos_x = 0;
	pos_y = 0;
	layer = -2;
	button = 590,10,<exitpressed.bmp>,<exit.bmp>,<exitover.bmp>,game_exit(),NULL,NULL;
	flags = visible,refresh,overlay;
}
panel panel_editor2
{
	pos_x = 130;
	pos_y = 37;
	layer = -2;
	bmap = titlepic;
	flags = visible, overlay;
}

function newgamestart
{
	panel_editor3.visible = off;
	loadscreen.visible = on;
	wait(5);
	level_load(firstlevel);
	mouse_off();
	panel_editor2.visible = off;
	loadscreen.visible = off;
	panel_editor.visible = off;
	backgroundP.visible = on;
	displayscore.visible = on;
}




function pickupcoin
{
	if(event_type == event_TRIGGER && you == player)
	{
		snd_play(coinpickup, 50,0);
		wait(1); // wait one frame before removing an entity in an event function
		score += (1);
		ent_REMOVE(MY);
	}
}

action coin
{
	MY.TRIGGER_RANGE = 34;
	my.enable_TRIGGER = on;
	my.event = pickupcoin;
}




function stabonspike
{
	if(event_type==event_trigger)
	{
		if(you.SKILL9 > -1)
		{
			you.SKILL9 -= 100;
			wait(1);
		}
	}
}

action spike
{
	my.trigger_range = 17;
	my.enable_trigger = on;
	my.event = stabonspike;
}

function rope_action()
{
	while(1)
	{	
		gravity = 0;
		if (key_a && you.z < my.max_z) 
		{
			you.gravity = 0;
			you.z += 0.003;
		}
		if (key_s && you.z > my.min_z) // go down 
		{ 
			you.gravity = 0;
			YOU.Z -= 0.003;
		}
		wait(1);
	}			
}

action rope 
{ 
	my.enable_trigger = on;
	my.trigger_range = 34;
	my.event = rope_action;
} 

var visin = 0;

function completedalevel
{
	on_anykey = null;
	wait(5);
	level_load(next_level);	
}

action endoflevel
{
	my.trigger_range = 10;
	my.enable_trigger = on;
	my.event = completedalevel;
}
panel snicksmsg1
{
	window = 200,110,300,200,snicksm1,0,0;
	pos_x=0;
	pos_y=0;
	flags = refresh, overlay;
}

function snicks1
{
	if(event_type==event_trigger)	
	{
		snicksmsg1.visible = on;
		ent_playsound(my, snickering, 100);
		wait(1);
		snicksmsg1.visible = off;
	}
}
action snicksmsger1
{
	my.trigger_range = 10;
	my.enable_trigger = on;
	my.event = snicks1;
}
function pickupcargo
{
	if(event_type == event_TRIGGER && you == player)
	{
		snd_play(coinpickup, 50,0);
		wait(1); // wait one frame before removing an entity in an event function
		cargo -= (1);
		if(cargo <= 0)
		{
			wait(5);
			displaycargo.visible = off;
			backgroundPcargo.visible = off;
			loadscreen.visible = on;
				snd_play(levelfinish, 100, 0);
			level_load("mountain2.wmb");
		}
		ent_REMOVE(MY);
	}
}

action cargobox
{
	MY.TRIGGER_RANGE = 34;
	my.enable_TRIGGER = on;
	my.event = pickupcargo;
}

action mouseon
{
if(loadscreen.visible == on){loadscreen.visible = off;}
if(presentation_.visible == on){presentation_.visible = off;}
mouse_toggle();
}